FD_INFO *find_address_info(struct in6_addr *addr, INTERFACE *interface){
  FD_INFO *temp_fd_info;

  // Imp: if(IN6_ARE_ADDR_EQUAL(&interface->link_local_fd->i_addr->ip_addr, addr))
  if(IN6_ARE_ADDR_EQUAL(interface->link_local_addr, addr))
    return interface->link_local_fd;

  for(temp_fd_info = interface->ip_addr_fd_head;
      temp_fd_info;
      temp_fd_info = temp_fd_info->next){
    if(IN6_ARE_ADDR_EQUAL(&temp_fd_info->i_addr->ip_addr, addr))
      return temp_fd_info;
  }
  return NULL;
}

int delete_address_info(struct in6_addr *addr, INTERFACE *interface){
  /* Returns fd if successful and -1 on failure */
  FD_INFO *temp_fd_info, *prev_fd_info;
  int fd;
 
  for(prev_fd_info = NULL, temp_fd_info = interface->ip_addr_fd_head;
      temp_fd_info;
      prev_fd_info = temp_fd_info, temp_fd_info = temp_fd_info->next){

    if(IN6_ARE_ADDR_EQUAL(&temp_fd_info->i_addr->ip_addr, addr)){
      fd = temp_fd_info->fd;
      close(temp_fd_info->fd);

      if(prev_fd_info)
	prev_fd_info->next = temp_fd_info->next;
      else
	interface->ip_addr_fd_head = temp_fd_info->next;
      free(temp_fd_info);
      return fd;
    }
  }
  return -1;
  
}

void delete_address(struct in6_addr *addr, INTERFACE *interface){
  IADDR *temp_iaddr;

  for(temp_iaddr = interface->addr_list_head;
      temp_iaddr;
      temp_iaddr = temp_iaddr->next
      ){
    if(IN6_ARE_ADDR_EQUAL(&temp_iaddr->ip_addr, addr)){
      delete_from_list(temp_iaddr, &interface->addr_list_head);
    }
  }
  
}

