# include "../lib/solicit_params.h"

int handle_solicit(){
  solicit               sol;
  struct solicit_params *cp;
  INTERFACE             *temp;
  uint8_t               size;
  
  if(header.index == 0)
    return 0;

  cp                            = (struct solicit_params *) (recv_msg + n);
  temp                          = (uint32_t *) cp;
  *temp                         = ntohl(*temp);

  bzero((char *) &sol, sizeof(sol));
  sol.msg_type                  = 1;
  sol.c                         = cp.c;
  sol.p                         = cp.p;
  sol.reserved                  = 0;
  sol.prefix_len                = 0;
  sol.solicit_id                = 0; /* process only the first Advertise msg. Use solicit_id++ for more */
  sol.client_link_local_addr    = recent_if->link_local_addr;
  
#ifdef DEBUG 
  printf("\n\nsol:-> = %u:8 %u:1 %u:1 %u:6 %u:7 %u:9\n",
	 sol.msg_type,
	 sol.c,
	 sol.p,
	 sol.reserved,
	 sol.prefix_len,
	 sol.solicit_id);
  
  printf("client link local address = %s\n",
	 inet_ntop(AF_INET6, &sol.client_link_local_addr, name, 127));
#endif
  
  temp  = (uint32_t *) &sol;
  /* Imp: Convert to network byte order */
  *temp = htonl(*temp);
  
  size  = sizeof(sol);
  memcpy((send_msg + n), &sol, size);
  if(send(server_sockfd,...) != size)
  return sizeof(sol);
}
