typedef struct fd_accept_list FD_ACCEPT_LIST;
typedef struct fd_init_list   FD_INIT_LIST;
typedef struct rec_multicast  REC_MULTICAST;

struct rec_multicast{
  REC_MULTICAST       *next;
  int                  fd;
  struct sockaddr_in6  m_sock;
};

struct fd_accept_list{
  FD_ACCEPT_LIST *next;
  int             fd;                 /* Note this fd is tcp_fd obtained by accept */
};

struct fd_init_list{
  /*
   * This is list of fds on which init has been done.
   */
  FD_INIT_LIST    *next;
  FD_INFO         *if_fd;             /* pointer to UDP fd i/f would use for talking to SERVER */
  //struct in6_addr *ip_addr;           /* This ip addr is to be used for this msg to SERVER     */
  INTERFACE       *interface;         /* init by appl has chosen this interface                */
  int              tcp_fd;            /* TCP fd obtained via accept                            */
  char             *msg;              /* Last message sent to server by the appl               */
  uint16_t         msg_len;           /* Last message's length                                 */
  struct sockaddr_in6 serv_sockaddr;  /* Address of server to whom msg is to be sent           */
  TIME             when_sent;         /* When was this message sent                            */
  TIME             next_transmission; /* Next transmission of message at                       */
  uint16_t         timeout;           /* timeout for this message in millisecs                 */

  uint16_t         msg_type;          /* Message type of msg sent by appl                      */
  uint16_t         pid;               /* pid of the application                                */
  uint32_t         request_no;        /* request no of the application                         */
  char             msg_data[64];      /* Message specific data sent by appl. ex for init c = 1.*/

  uint32_t         no_of_attempts    ;/* No. of times this message has been sent(attempts made)*/
  uint8_t          want_to_reconfig:1;/* Whether appl wants to reconfigure                     */
  uint8_t          request_pending :1;/* Whether appl's request is still pending.              */
  uint8_t          adv_received    :1;/* Whether advertise has been received if msg = solicit  */
  SERVER_SOLICIT_INFO *sol_list_head; /* List of servers obtained via solicit                  */
  TIME             advertise_time;    /* Time of 1'st advertise of last solicit                */
  uint16_t         sol_xact_id;       /* Sol or Xact id used for this appl's current request   */

  REC_MULTICAST   *rec_list_head;     /* List of reconfigure multicast addresses joined        */

  /* Other init parameters */
  
};

void insert(FD_ACCEPT_LIST *entry, FD_ACCEPT_LIST **head){
  //if(*head != NULL)
  entry->next = *head;
  *head = entry;
}

void delete(FD_ACCEPT_LIST *prev, FD_ACCEPT_LIST *entry, FD_ACCEPT_LIST **head){

}
