# include <stdio.h>
# include <errno.h>
# include <signal.h>
# include <netdb.h>
# include <string.h>
# include <stdlib.h>
# include <syslog.h>

# include <sys/types.h>
# include <sys/socket.h>
# include <sys/time.h>
# include <sys/param.h>
# include <sys/file.h>
# include <sys/ioctl.h>
# include <sys/sysctl.h>
# include <sys/uio.h>

# include <netinet/in.h>

# include <arpa/inet.h>

# include <net/if.h>
# include <net/if_dl.h>
# include <net/route.h>

# include "max_dns_name.h"
# include "in6_addr_list.h"
# include "host_subnet_interface_structures.h"
# include "lease_structure.h"

//extern void discover_interfaces(INTERFACE **in_head);
//extern void print(INTERFACE **in_head);

main(int argc, char *argv[]){
  INTERFACE *in_list_head = NULL;
  LEASE *lease_list_head, *lease;
  SUBNET *subnet_list_head;
  INTERFACE  **temp, *t;
  SUBNET *sub;

  if(argc != 3){
    printf("Incorrect number of arguments to main\n");
    exit(0);
  }
  discover_interfaces(&in_list_head);
  getchar();
  print(&in_list_head);
  getchar();
  
  parse_address_properties_file(argv[1], &subnet_list_head, in_list_head);
  for(sub = subnet_list_head; sub; sub = sub->next){
    print_subnet(sub);
  }
  for(t = in_list_head; t; t = t->next){
    print_interface(t);
  }
  read_lease_file(argv[2], &lease_list_head);
  for(lease = lease_list_head; lease; lease = lease->next)
    print_lease(lease);
 
}
