#ifndef DEBUG
#define DEBUG
#endif

TIME delete_expired_leases(LEASE **head) {
  TIME    min, expiry_time, current_time;
  LEASE  *t_lease;
  char    name[64];

  min.tv_sec  = -1;

  while(*head) {
    if(has_expired(*head)) {
      t_lease = *head;
      *head   = (*head)->next;
#ifdef DEBUG
      printf("Deleting lease...........\n");
      print_lease(t_lease);
#endif
      free(t_lease);
      continue;
    }
    else {
      expiry_time.tv_sec  = (*head)->when_leased.tv_sec + (*head)->valid_lifetime;
      expiry_time.tv_usec = (*head)->when_leased.tv_usec;
      
      if(min.tv_sec == -1) {
	min.tv_sec  = (*head)->when_leased.tv_sec + (*head)->valid_lifetime;
	min.tv_usec = (*head)->when_leased.tv_usec;
      }
      else if(DIFF_IN_MS(min, expiry_time) > 0 && DIFF_IN_MICRO(min, expiry_time) > 0)
	min = expiry_time;
    }
    head = &(*head)->next;
  }

  if(gettimeofday(&current_time, NULL) == -1)
    errx("Error in gettimeofday. Exiting...\n");

  if(min.tv_sec == -1) {
    SET_TIMEOUT(min, SLEEP_TIME * 100);
    printf("<1> min = %d %d\n", min.tv_sec, min.tv_usec);
    return min;
  }

  printf("<2>min = %d %d current = %u %u \n", min.tv_sec, min.tv_usec,
	 current_time.tv_sec, current_time.tv_usec );

  min.tv_sec  -= current_time.tv_sec;
  min.tv_usec -= current_time.tv_usec;
  if(min.tv_usec < 0) {
    min.tv_usec += 1000000;
    min.tv_sec--;
  }

  printf("<3>min = %d %d current = %u %u \n", min.tv_sec, min.tv_usec,
	 current_time.tv_sec, current_time.tv_usec );
  return min;
}
