typedef struct in6_addr_list        IN6_ADDR_LIST;
typedef struct s_in6_addr_list      S_IN6_ADDR_LIST;
typedef struct in6_addr_with_prefix IN6_ADDR_WITH_PREFIX;
typedef IN6_ADDR_WITH_PREFIX        PREFIX_LIST;
typedef struct range                RANGE;
typedef struct host                 HOST;
typedef struct subnet               SUBNET;
typedef struct interface            INTERFACE;


struct in6_addr_list{

  struct in6_addr_list *next;
  struct in6_addr       ip_addr;

};

struct s_in6_addr_list{

  uint32_t         default_preferred_lifetime;
  uint32_t         default_valid_lifetime;
  uint32_t         max_preferred_lifetime;
  uint32_t         max_valid_lifetime;
  uint8_t          scope: 3;
  uint8_t          dns_update_A_allowed: 1;
  uint8_t          dns_update_P_allowed: 1;

  IN6_ADDR_WITH_PREFIX *dn_server_list_head;
  char                  domain_name_suffix[MAX_DNS_NAME];
  void                 *parent;

  uint8_t                 prefix_len;
  struct in6_addr         ip_addr;
  struct s_in6_addr_list *next;

};
