typedef struct lease{
  struct lease    *next;
  struct in6_addr  leased_to;/* Link local addr of node to which addr has been leased */

  union{
    struct{
      struct in6_addr  subnet_prefix;
      uint8_t          subnet_prefix_len;
    }st;
    
    char interface_name[IFNAMSIZ];
  }un;

  struct in6_addr  ip_addr;
  uint8_t          ip_addr_prefix_len;
  uint8_t          scope;
  uint16_t         xact_id;
  struct timeval   when_leased;
  uint32_t         preferred_lifetime;
  uint32_t         valid_lifetime;
  char             dns_name[MAX_DNS_NAME];

  uint32_t         default_preferred_lifetime;
  uint32_t         default_valid_lifetime;
  uint32_t         max_preferred_lifetime;
  uint32_t         max_valid_lifetime;
  uint8_t          dns_update_A_allowed: 1;
  uint8_t          dns_update_P_allowed: 1;
  uint8_t          A         : 1; /* whether dns has been updated */
  uint8_t          P         : 1;
  uint8_t          onlink    : 1;
  uint8_t          abandoned : 1;/* Imp: */
  uint8_t          old       : 1;/* Tells whether the lease is already in lease list */
  int              status_addr;
  int              line_no_in_file;
}LEASE;
