# include <stdio.h>
# include <errno.h>
# include <signal.h>
# include <netdb.h>
# include <string.h>
# include <stdlib.h>
# include <syslog.h>

# include <sys/types.h>
# include <sys/socket.h>
# include <sys/time.h>
# include <sys/param.h>
# include <sys/file.h>
# include <sys/ioctl.h>
# include <sys/sysctl.h>
# include <sys/uio.h>

# include <netinet/in.h>

# include <arpa/inet.h>

# include <net/if.h>
# include <net/if_dl.h>
# include <net/route.h>

# define MAX_TOKENS_PER_LINE 8
# define MAX_TOKEN_LEN       256

extern char line[MAX_TOKENS_PER_LINE][MAX_TOKEN_LEN];
extern uint line_no;
extern char name[];

int read_line(FILE *fp){
  int i = 0, n, k = 0;
  char c;
  
  while(1){
    fscanf(fp, "%*[ \t]");
    n = fscanf(fp, "%[^\n\t ]", line[i]);
    if(n <= 0){
      c = fgetc(fp);
      if(c == '\n'){
	line_no++;
	break;
      }
      if(c == EOF)
	return -1;
    }
    i++;
  }
  return i;
}


void print_line(int i){
  int k;
  
  printf("line %d <%d>: ", line_no, i);
  for(k = 0; k < i; k++)
    printf("<%s> ", line[k]);
  printf("\n");
}

int read_useful_line(FILE *fp){
  int i;

  while(1){
    i = read_line(fp);
    if(i == -1)
      return i;
    if(i != 0 && line[0][0] != '#'){
      //print_line(i);
      return i;
    }
  }
}

uint8_t get_and_delete_prefix_len(char addr[]){
  int i;
  
  for(i = strlen(addr) - 1; i > 0; i--)
    if(addr[i] == '/')
      break;
  
  if(i == 0)
    errx(1, "Address doesn't contain prefix. Successfully read %u lines\n", line_no);
  
  addr[i] = '\0';
  return atoi(addr + i + 1);
}
