# include <stdio.h>
# include <errno.h>
# include <signal.h>
# include <netdb.h>
# include <string.h>
# include <stdlib.h>
# include <syslog.h>

# include <sys/types.h>
# include <sys/socket.h>
# include <sys/time.h>
# include <sys/param.h>
# include <sys/file.h>
# include <sys/ioctl.h>
# include <sys/sysctl.h>
# include <sys/uio.h>

# include <netinet/in.h>

# include <arpa/inet.h>

# include <net/if.h>
# include <net/if_dl.h>
# include <net/route.h>
# define TEN 10

int IN6_ARE_PREFIXES_EQUAL(struct in6_addr *a1, struct in6_addr *a2, int prefix_len){
  int full_bytes     = prefix_len / 8;
  int remaining_bits = prefix_len % 8;
  int i;
  char *c1, *c2, mask;
  
  for(c1 = (char *)a1, c2 = (char *)a2, i = 0; i < full_bytes; i++, c1++, c2++)
    if(*((u_int8_t *)c1) != *((u_int8_t *)c2))
      return 0;
  
  if(remaining_bits == 0)
    return 1;

  mask = ((1 << remaining_bits) - 1) << (8 - remaining_bits);
  if((*c1 && mask) != (*c2 && mask))
    return 0;

  return 1;
  
}


int compare(struct in6_addr *a1, struct in6_addr *a2) {
  int i, size = sizeof(*a1);

  for(i = 0; i < size; i++) {
    if(a1->s6_addr8[i] == a2->s6_addr8[i])
      continue;
    return (a1->s6_addr8[i] - a2->s6_addr8[i]);
  }
  return 0;
}

void increment_in6_addr(struct in6_addr *addr) {
  int i, temp;
  int max = 255;
  char name[64];

  for(i = sizeof(*addr) - 1; i >= 0; i--) {
    temp = addr->s6_addr8[i] + 1;
    if(temp <= max) {
      addr->s6_addr8[i] = temp;
      return;
    }
    addr->s6_addr8[i] = 1;
  }
}

struct in6_addr *find_unleased_addr_in_range(struct in6_addr *start, struct in6_addr *end){
  struct in6_addr temp_addr, *result;
  char name[64];

  for(temp_addr = *start; compare(&temp_addr, end) <= 0;
      increment_in6_addr(&temp_addr)) {
    printf("# %s %d\n", inet_ntop(AF_INET6, &temp_addr, name, 64), compare(&temp_addr, end));
    getchar();
  }
  return NULL;
}

main(){
  struct in6_addr a1, a2, *t1, **t2;
  char name1[100], name2[100];
  int len;
  time_t t;
  struct tm *tm;
  uint8_t a = 1, error = TEN;

  while(1){
    printf("Enter addr1: ");
    scanf("%s", name1);
    if(inet_pton(AF_INET6, name1, &a1) <= 0)
      errx(1, "Error converting address to binary\n");

    printf("Enter addr2: ");
    scanf("%s", name2);
    if(inet_pton(AF_INET6, name2, &a2) <= 0)
      errx(1, "Error converting address to binary\n");
    getchar();

    find_unleased_addr_in_range(&a1, &a2);
  }
  


  printf("%d %d %d %d %d\n", sizeof(t1), sizeof(*t1), sizeof(t2), sizeof(*t2), sizeof(**t2));
  printf("%d\n", a << 10);
  getchar();
  time(&t);
  if(t == -1)
    errx(1, "error in time");

  tm = localtime(&t);

  printf("tm_sec = %d\n", tm->tm_sec);
  printf("tm_min = %d\n", tm->tm_min);
  printf("tm_hour = %d\n", tm->tm_hour);
  printf("tm_mday = %d\n", tm->tm_mday);
  printf("tm_mon = %d\n", tm->tm_mon);
  printf("tm_year = %d\n", tm->tm_year);
  printf("tm_wday = %d\n", tm->tm_wday);
  printf("tm_yday = %d\n", tm->tm_yday);
  printf("tm_isdst = %d\n", tm->tm_isdst);
  printf("tm_gmtoff = %d\n", tm->tm_gmtoff);
  printf("tm_zone = %s\n", tm->tm_zone);
  
  len = 0;
  while(len < 10){
    printf("%d: Enter: ", len);
    getchar();
    if(len == 5)
      continue;
    len++;
  }
  while(1){
    printf("Enter addr1: ");
    scanf("%s", name1);
    if(inet_pton(AF_INET6, name1, &a1) <= 0)
      errx(1, "Error converting address to binary\n");

    printf("Enter addr2: ");
    scanf("%s", name2);
    if(inet_pton(AF_INET6, name2, &a2) <= 0)
      errx(1, "Error converting address to binary\n");

    printf("Enter prefix_len: ");
    scanf("%d", &len);
    printf("%s %s \n", name1, name2);
    printf("%s %s %d\n",
	   inet_ntop(AF_INET6, &a1, name1, 64),
	   inet_ntop(AF_INET6, &a1, name2, 64),
	   len);
    if(IN6_ARE_PREFIXES_EQUAL(&a1, &a2, len) == 1)
      printf("\n..............Equal\n\n");
    else
      printf("\n!!!!!!!!!!!!!!Unequal\n\n");
  }
}
