# include "inet.h"
/*
 * Server listens on 547, sends on whatever src port it likes
 * Client listens on 546, sends on whatever src port it likes
 *
 * int   SERVER_PORT    = 547;
 * int   CLIENT_PORT    = 546;
 */

main(int argc, char *argv[]){
  
  int                 sockfd, sockfd_recv, serv_socklen, n, msg_no = 1, temp;
  struct sockaddr_in6 cli_sockaddr, cli_sockaddr_recv, serv_sockaddr, recv_serv_sockaddr;
  char                send_msg[MAX_MSG_SIZE],recv_msg[MAX_MSG_SIZE];
  unsigned int        interface_index;
  char                name[128], name_[128];
  int                 on;
  fd_set              f;
  struct timeval      timeout;

  struct CMSG{
    struct cmsghdr    c_cm;
    struct in6_pktinfo c_pi;
  }c_cmsg;

#define pi	      c_cmsg.c_pi

  struct msghdr       msg;
  struct iovec        iov[1];

  /* Fill in the server socket with necessary data */

  bzero((char *) &serv_sockaddr, sizeof(serv_sockaddr));

#ifdef SIN6_LEN
  serv_sockaddr.sin6_len      = sizeof(serv_sockaddr);
#endif

  serv_sockaddr.sin6_family   = AF_INET6;
  serv_sockaddr.sin6_port     = htons(SERVER_PORT);
  serv_sockaddr.sin6_flowinfo = 0;   
  n = inet_pton(AF_INET6, SERVER_ADDRESS,
		& serv_sockaddr.sin6_addr);
  if(n != 1){
    if(n < 0)
      err_dump("Unknown AF(first) argument. Exiting...");
    else
      err_dump("Invalid address string. Exiting...");
  }

  serv_sockaddr.sin6_scope_id = 0;


  /* Open a socket for the client and bind an address */
  sockfd         = socket(AF_INET6, SOCK_DGRAM, 0);
  sockfd_recv    = socket(AF_INET6, SOCK_DGRAM, 0);//socket(AF_INET6, SOCK_DGRAM, 17);


  if(sockfd < 0 || sockfd_recv < 0)
    err_dump("Error in opening datagram socket! Exiting...");


  bzero((char *) &cli_sockaddr, sizeof(cli_sockaddr));

#ifdef SIN6_LEN
  cli_sockaddr.sin6_len      = sizeof(cli_sockaddr);
#endif

  cli_sockaddr.sin6_family   = AF_INET6;
  cli_sockaddr.sin6_port     = htons(0);
  cli_sockaddr.sin6_flowinfo = 0;
  cli_sockaddr.sin6_addr     = in6addr_any;
  cli_sockaddr.sin6_scope_id = 0;



  bzero((char *) &cli_sockaddr_recv, sizeof(cli_sockaddr_recv));

#ifdef SIN6_LEN
  cli_sockaddr_recv.sin6_len      = sizeof(cli_sockaddr_recv);
#endif

  cli_sockaddr_recv.sin6_family   = AF_INET6;
  cli_sockaddr_recv.sin6_port     = htons(CLIENT_PORT); 
  cli_sockaddr_recv.sin6_flowinfo = 0;
  cli_sockaddr_recv.sin6_addr     = in6addr_any;
  cli_sockaddr_recv.sin6_scope_id = 0;

  bzero (&pi, sizeof (pi));
  on = 1;
  if (setsockopt(sockfd_recv, IPPROTO_IPV6, IPV6_RECVPKTINFO,
		 &on, sizeof(on)) == -1){
		 //(char *) &pi, sizeof (pi)) == -1) {
    err_dump("setsockopt(IPV6_PKTINFO).Exiting...");
    exit(0);
  }
  printf("addr = %s\n Press Enter to continue: ", inet_ntop(AF_INET6, &pi.ipi6_addr, name, 127));
  getchar();



  interface_index = 1;
  temp = setsockopt(sockfd, IPPROTO_IPV6, IPV6_MULTICAST_IF, (char *) &interface_index, sizeof(interface_index));
  if(temp == -1)
    err_dump("Couldn't set socket option to IPV6_MULTICAST_IF. Exiting...");


  if(bind(sockfd, (struct sockaddr *) &cli_sockaddr,
	  sizeof(cli_sockaddr)) < 0)
    err_dump("Error while binding address! Exiting...");

  if(bind(sockfd_recv, (struct sockaddr *) &cli_sockaddr_recv,
	  sizeof(cli_sockaddr_recv)) < 0)
    err_dump("Error while binding address! Exiting...");

  while(1){
    sprintf(send_msg,"This is message no. %d from client",msg_no);
    n = strlen(send_msg);

    if((temp = sendto(sockfd, send_msg, n, 0, (struct sockaddr *) &serv_sockaddr, 
	      sizeof(serv_sockaddr))) != n){
      printf("Sent %d bytes\n",temp);
      err_dump("Error in sendto! Exiting...");
    }

    printf("Sent: Client to server: %s serv_addr = %s localaddr = %s\n\n",
	   send_msg,
	   inet_ntop(AF_INET6, &serv_sockaddr.sin6_addr, name, 127),
	   inet_ntop(AF_INET6, &cli_sockaddr.sin6_addr, name_, 127));

    printf("*******Before recv server = %s\n", inet_ntop(AF_INET6, &recv_serv_sockaddr.sin6_addr, name, 127));
    //printf("here1\n");

    iov[0].iov_base = recv_msg;
    iov[0].iov_len = MAX_MSG_SIZE;

    msg.msg_name = (caddr_t) &recv_serv_sockaddr;
    msg.msg_namelen = sizeof(recv_serv_sockaddr);
    msg.msg_iov = &iov[0];
    msg.msg_iovlen = 1;
    // msg.msg_control = NULL;
    // msg.msg_controllen = 0;
    msg.msg_control = (caddr_t)&c_cmsg;
    msg.msg_controllen = sizeof c_cmsg;
    // c_cmsg.c_cm.cmsg_len = sizeof c_cmsg.c_cm + sizeof c_cmsg.c_pi;
    //c_cmsg.c_cm.cmsg_level = IPPROTO_IPV6;
    //c_cmsg.c_cm.cmsg_type = IPV6_RECVPKTINFO;

    FD_ZERO(&f);
    FD_SET(sockfd_recv, &f);
    timeout.tv_sec = 1;
    timeout.tv_usec = 0;
    
    n = select(sockfd_recv + 1, &f, (fd_set *)0, (fd_set *)0, &timeout);
    printf("select = %d", n);
    c_cmsg.c_pi.ipi6_ifindex = 0;
    n = recvmsg(sockfd_recv, &msg, 0); //recv_msg, MAX_MSG_SIZE, 0,
		 // (struct sockaddr *) 0, (int *) 0);
		 // (struct sockaddr *) &recv_serv_sockaddr, &serv_socklen);
    printf("msg_control = %d controllen = %u\n", msg.msg_control, msg.msg_controllen);

    //on = sizeof(pi);
    //printf("sockopt = %d\n",getsockopt(sockfd_recv, IPPROTO_IPV6, IPV6_PKTINFO, &pi, &on));
    //printf("socklen = %d\n", msg.msg_namelen);//serv_socklen);
    //printf("addr = %s\n", 
    //   inet_ntop(AF_INET6, & ((struct CMSG *) msg.msg_control)->c_pi, name, 127));

    if(n < 0)
      err_dump("Error in recvfrom! Exiting...");

    recv_msg[n] = '\0';
    printf("Received Reply: Server to client: %s serv addr = %s port = %u. interface = %u\n",
	   recv_msg,
	   inet_ntop(AF_INET6, &recv_serv_sockaddr.sin6_addr, name, 127),
	   recv_serv_sockaddr.sin6_port,
	   c_cmsg.c_pi.ipi6_ifindex);

    printf("serv addr = %s\n", inet_ntop(AF_INET6, &pi.ipi6_addr, name, 127));
    //printf("To send more messages press return, ^C to quit.\n");
    getchar();
    msg_no++;
  }
}
