# include "inet.h"
/*
 * Server listens on 547, sends on whatever src port it likes
 * Client listens on 546, sends on whatever src port it likes
 *
 * int   SERVER_PORT    = 547;
 * int   CLIENT_PORT    = 546;
 */
extern const struct in6_addr in6addr_any;

main(int argc, char *argv[]){
  
  int                 sockfd, rep_sockfd, n, cli_socklen, reply_no = 1, temp;
  struct sockaddr_in6 cli_sockaddr, serv_sockaddr, rep_serv_sockaddr;
  char                recv_msg[MAX_MSG_SIZE + 1], send_msg[MAX_MSG_SIZE];
  char                name[128], name_[128];
  struct ipv6_mreq    socket_opt;
  fd_set              f;
  struct timeval      timeout;

  sockfd     = socket(AF_INET6, SOCK_DGRAM, 0);
  rep_sockfd = socket(AF_INET6, SOCK_DGRAM, 0);

  if(sockfd < 0)
    err_dump("Error in opening datagram socket! Exiting...");

  bzero((char *) &serv_sockaddr, sizeof(serv_sockaddr));
#ifdef SIN6_LEN
  serv_sockaddr.sin6_len      = sizeof(serv_sockaddr);            /* 4.3 BSD doesn't have this field      */
#endif

  serv_sockaddr.sin6_family   = AF_INET6;                         /* Family as required for Ipv6          */
  serv_sockaddr.sin6_port     = htons(SERVER_PORT);               /* Server listens on SERVER_PORT        */
  serv_sockaddr.sin6_flowinfo = htonl(0);                         /* Flow & Traffic Class are unimportant */

  n = inet_pton(AF_INET6, SERVER_ADDRESS,                         /* Converting address to binary format. */
		& serv_sockaddr.sin6_addr);
  
  if(n <= 0){
    if(n < 0)
      err_dump("Unknown AF(first) argument. Exiting...");
    else
      err_dump("Invalid address string. Exiting...");
  }





  bzero((char *) &rep_serv_sockaddr, sizeof(rep_serv_sockaddr));

#ifdef SIN6_LEN
  rep_serv_sockaddr.sin6_len      = sizeof(rep_serv_sockaddr);            /* 4.3 BSD doesn't have this field      */
#endif

  rep_serv_sockaddr.sin6_family   = AF_INET6;                         /* Family as required for Ipv6          */
  rep_serv_sockaddr.sin6_port     = htons(0);               /* Server listens on SERVER_PORT        */
  rep_serv_sockaddr.sin6_flowinfo = htonl(0);                         /* Flow & Traffic Class are unimportant */
  rep_serv_sockaddr.sin6_addr     = in6addr_any;
  rep_serv_sockaddr.sin6_scope_id = 0;                                /* Not really required.                 */
  if((n = bind(rep_sockfd, (struct sockaddr *) &rep_serv_sockaddr,
	  sizeof(rep_serv_sockaddr))) < 0){
    // printf("bind: %d\n",n);
    printf("address = %s\n",inet_ntop(AF_INET6, &serv_sockaddr.sin6_addr, name, 127));
    err_dump("Error while binding address! Exiting...");
  }





  /* rep_serv_sockaddr.sin6_addr     = in6addr_any;                   /* SERVER_ADDRESS                       */
  printf("address in int = %02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x \nstring = <<%s>>\n\n", 
	 serv_sockaddr.sin6_addr.s6_addr[0], 
	 serv_sockaddr.sin6_addr.s6_addr[1], 
	 serv_sockaddr.sin6_addr.s6_addr[2], 
	 serv_sockaddr.sin6_addr.s6_addr[3], 
	 serv_sockaddr.sin6_addr.s6_addr[4], 
	 serv_sockaddr.sin6_addr.s6_addr[5], 
	 serv_sockaddr.sin6_addr.s6_addr[6], 
	 serv_sockaddr.sin6_addr.s6_addr[7], 
	 serv_sockaddr.sin6_addr.s6_addr[8], 
	 serv_sockaddr.sin6_addr.s6_addr[9], 
	 serv_sockaddr.sin6_addr.s6_addr[10], 
	 serv_sockaddr.sin6_addr.s6_addr[11], 
	 serv_sockaddr.sin6_addr.s6_addr[12], 
	 serv_sockaddr.sin6_addr.s6_addr[13], 
	 serv_sockaddr.sin6_addr.s6_addr[14], 
	 serv_sockaddr.sin6_addr.s6_addr[15], 
	 SERVER_ADDRESS);
  printf("address back = %s \ncheck = %s\n\n",inet_ntop(AF_INET6, &serv_sockaddr.sin6_addr, name, 127),name);
  /*serv_sockaddr.sin6_addr     = in6addr_any;                      /* SERVER_ADDRESS                       */
  serv_sockaddr.sin6_scope_id = 0;                                /* Not really required.                 */

  socket_opt.ipv6mr_multiaddr = serv_sockaddr.sin6_addr;
  socket_opt.ipv6mr_interface = if_nametoindex("ed0");
  printf("index = %u\n",socket_opt.ipv6mr_interface);
  temp = setsockopt(sockfd, IPPROTO_IPV6, IPV6_JOIN_GROUP, (char *) &socket_opt, sizeof(socket_opt));
  if(temp == -1)
    err_dump("Couldn't set socket option to IPV6_JOIN_GROUP. Exiting...");

  if((n = bind(sockfd, (struct sockaddr *) &serv_sockaddr,
	  sizeof(serv_sockaddr))) < 0){
    printf("bind: %d\n",n);
    printf("address = %s\n",inet_ntop(AF_INET6, &serv_sockaddr.sin6_addr, name, 127));
    err_dump("Error while binding address! Exiting...");
  }

/*printf("address = %s\n",inet_ntop(AF_INET6, &serv_sockaddr.sin6_addr, name, 127));*/

  while(1){
    cli_socklen  = sizeof(cli_sockaddr);


    FD_ZERO(&f);
    FD_SET(sockfd, &f);
    timeout.tv_sec  = 24 * 60 * 60;
    timeout.tv_usec = 0;
    
    n = select(sockfd + 1, &f, (fd_set *)0, (fd_set *)0, &timeout);
    printf("select = %d ", n);
    if(n < 0)
      printf("\a");

    if(n == 0){
      timeout.tv_sec  = 0;
      timeout.tv_usec = 0;
      n = select(sockfd + 1, &f, (fd_set *)0, (fd_set *)0, &timeout);
      printf("select = %d again", n);
      printf("At server\a\a\a\a\a\a\a\a\a\a\a\a\a\n");
      continue;
    }
    
    timeout.tv_sec  = 0;
    timeout.tv_usec = 0;
    n = select(sockfd + 1, &f, (fd_set *)0, (fd_set *)0, &timeout);
    printf("select = %d again", n);
    
    n            = recvfrom(sockfd, recv_msg, MAX_MSG_SIZE, 0,
			    (struct sockaddr *) &cli_sockaddr, &cli_socklen);

    n = select(sockfd + 1, &f, (fd_set *)0, (fd_set *)0, &timeout);
    printf("\nselect = %d after reading..........\n", n);

    if(n < 0)
      err_dump("Error in recvfrom! Exiting...");


    printf("\nsocklen = %d\n\n", cli_socklen);
    recv_msg[n] = '\0';
    printf("Received: Client to server: %s cli_addr = %s\n",
	   recv_msg,
	   inet_ntop(AF_INET6, &cli_sockaddr.sin6_addr, name, 127));
    sprintf(send_msg,"This is reply no. %d from server",reply_no);
    cli_sockaddr.sin6_port     = htons(CLIENT_PORT);              /* The client would be listening on CLIENT_PORT */  

    if(sendto(rep_sockfd, send_msg, strlen(send_msg), 0, (struct sockaddr *) &cli_sockaddr, cli_socklen) < 0)
      /*          \___________________________________
       *                                              \
       * For the moment let the server send using same port as it was listening on. 
       * You can change the port no. later for sending.
       */
      err_dump("Error in sendto! Exiting...");
    printf("Sent: Server to client: %s cli addr = %s server = %s\n",
	   send_msg,
	   inet_ntop(AF_INET6, &cli_sockaddr.sin6_addr, name, 127),
	   inet_ntop(AF_INET6, &rep_serv_sockaddr.sin6_addr, name_, 127));
    reply_no++;
  }
}
