# include "inet.h"

main(int argc, char *argv[]){
  
  int                 sockfd, serv_socklen, n, msg_no = 1, temp;
  struct sockaddr_in6 cli_sockaddr, serv_sockaddr;
  char                send_msg[MAX_MSG_SIZE],recv_msg[MAX_MSG_SIZE];
  char                name[128], name_[128];

  bzero((char *) &serv_sockaddr, sizeof(serv_sockaddr));

#ifdef SIN6_LEN
  serv_sockaddr.sin6_len      = sizeof(serv_sockaddr);            /* 4.3 BSD doesn't have this field      */
#endif

  serv_sockaddr.sin6_family   = AF_INET6;                         /* Family as required for Ipv6          */
  serv_sockaddr.sin6_port     = htons(SERVER_PORT);               /* Server listens on SERVER_PORT        */
  serv_sockaddr.sin6_flowinfo = 0;                                /* Flow & Traffic Class are unimportant */
  serv_sockaddr.sin6_addr     = in6addr_loopback;                 /* Server is on same machine as client  */
  serv_sockaddr.sin6_scope_id = 0;                                /* Not really required.                 */



  bzero((char *) &cli_sockaddr, sizeof(cli_sockaddr));

#ifdef SIN6_LEN
  cli_sockaddr.sin6_len       = sizeof(cli_sockaddr);             /* 4.3 BSD doesn't have this field      */
#endif

  cli_sockaddr.sin6_family    = AF_INET6;                         /* Family as required for Ipv6          */
  cli_sockaddr.sin6_port      = htons(0);                         /* Let client send on CLIENT_PORT       */
                                                                  /* Change later to required port.       */
  cli_sockaddr.sin6_flowinfo  = 0;                                /* Flow & Traffic Class are unimportant */
  cli_sockaddr.sin6_addr      = in6addr_any;                      /* CLIENT_ADDRESS                       */
  cli_sockaddr.sin6_scope_id  = 0;                                /* Not really required.                 */

  /* Open a socket for the client and bind an address */
  sockfd                      = socket(AF_INET6, SOCK_STREAM, 0);

  if(sockfd < 0 )
    err_dump("Error in opening stream socket! Exiting...");

  if(bind(sockfd, (struct sockaddr *) &cli_sockaddr,
	  sizeof(cli_sockaddr)) < 0)
    err_dump("Error while binding address! Exiting...");

  if(connect(sockfd, (struct sockaddr *) &serv_sockaddr, sizeof(serv_sockaddr)) < 0)
    err_dump("Error in connecting to server. Exiting...");

  while(1){
    sprintf(send_msg,"This is message no. %d from client",msg_no);
    n = strlen(send_msg);

    if((temp = send(sockfd, send_msg, n, 0)) != n){
      printf("Sent %d bytes\n",temp);
      err_dump("Error in send! Exiting...");
    }

    printf("Sent: Client to server: %s serv_addr = %s localaddr = %s\n\n",
	   send_msg,
	   inet_ntop(AF_INET6, &serv_sockaddr.sin6_addr, name, 127),
	   inet_ntop(AF_INET6, &cli_sockaddr.sin6_addr, name_, 127));
  
    n = recv(sockfd, recv_msg, MAX_MSG_SIZE, 0);

    if(n < 0)
      err_dump("Error in recv! Exiting...");
    if(n == 0)
      err_dump("Server closed connection");
    recv_msg[n] = '\0';
    printf("Received Reply: Server to client: %s\n", recv_msg);
    getchar();
    msg_no++;
    if(msg_no == 5){
      close(sockfd);
      exit(0);
    }
  }
}
