# include "inet.h"

main(){
  int fd;
  int childpid1, childpid2;
  struct sockaddr_in6 cli_sockaddr, serv_sockaddr;
  char send_msg[100];
  int temp;

  fd = socket(AF_INET6, SOCK_DGRAM, 0);
  if(fd < 0 )
    err_dump("Error in opening datagram socket! Exiting...");


  bzero((char *) &cli_sockaddr, sizeof(cli_sockaddr));

#ifdef SIN6_LEN
  cli_sockaddr.sin6_len      = sizeof(cli_sockaddr);             /* 4.3 BSD doesn't have this field      */
#endif

  cli_sockaddr.sin6_family   = AF_INET6;                         /* Family as required for Ipv6          */
  cli_sockaddr.sin6_port     = htons(0);                         /* Let client send on CLIENT_PORT       */
                                                                 /* Change later to required port.       */
  cli_sockaddr.sin6_flowinfo = 0;                                /* Flow & Traffic Class are unimportant */
  cli_sockaddr.sin6_addr     = in6addr_any;                      /* CLIENT_ADDRESS                       */
  cli_sockaddr.sin6_scope_id = 0;                                /* Not really required.                 */

  if(bind(fd, (struct sockaddr *) &cli_sockaddr,
	  sizeof(cli_sockaddr)) < 0)
    err_dump("Error while binding address! Exiting...");
 

  bzero((char *) &serv_sockaddr, sizeof(serv_sockaddr));

#ifdef SIN6_LEN
  serv_sockaddr.sin6_len      = sizeof(serv_sockaddr);            /* 4.3 BSD doesn't have this field      */
#endif

  serv_sockaddr.sin6_family   = AF_INET6;                         /* Family as required for Ipv6          */
  serv_sockaddr.sin6_port     = htons(SERVER_PORT);               /* Server listens on SERVER_PORT        */
  serv_sockaddr.sin6_flowinfo = 0;                                /* Flow & Traffic Class are unimportant */
  n = inet_pton(AF_INET6, SERVER_ADDRESS,                         /* Converting address to binary format. */
		& serv_sockaddr.sin6_addr);
  if(n != 1){
    if(n < 0)
      err_dump("Unknown AF(first) argument. Exiting...");
    else
      err_dump("Invalid address string. Exiting...");
  }

  serv_sockaddr.sin6_scope_id = 0;                                /* Not really required.                 */



  childpid1 = fork();
  if(childpid1 == -1){
    printf("error in fork\n");
    exit(1);
  }
  else if(childpid1 == 0){

#ifdef LOCK
    if(flock(fd, LOCK_EX|LOCK_NB) == -1){
      printf("error in locking by %d\n", getpid());
      exit(0);
    }
#endif

    sprintf(send_msg, "Message 1 from pid %d", getpid());
    n = strlen(send_msg);
    if((temp = sendto(fd, send_msg, n, 0, (struct sockaddr *) &serv_sockaddr, 
	      sizeof(serv_sockaddr))) != n){
      printf("Sent %d bytes\n",temp);
      err_dump("Error in sendto! Exiting...");
    }

    sleep(2);

    sprintf(send_msg, "Message 2 from pid %d", getpid());
    n = strlen(send_msg);
    if((temp = sendto(fd, send_msg, n, 0, (struct sockaddr *) &serv_sockaddr, 
	      sizeof(serv_sockaddr))) != n){
      printf("Sent %d bytes\n",temp);
      err_dump("Error in sendto! Exiting...");
    }

#ifdef LOCK
    if(flock(fd, LOCK_UN) == -1)
      printf("error in unlocking");
#endif
    exit(0);
  }

  else{
    childpid2 = fork();

    if(childpid2 == -1){
      printf("error in fork\n");
      exit(2);
    }

    else if(childpid2 == 0){
      
#ifdef LOCK
      if(flock(fd, LOCK_EX|LOCK_NB) == -1){
	printf("error in locking by %d\n", getpid());
	exit(0);
      }
#endif
      
      sendto(fd, );
      sleep(2);
      sendto(fd, );
      
#ifdef LOCK
      if(flock(fd, LOCK_UN) == -1)
	printf("error in unlocking");
#endif
      exit(0);
    }/* child ends */

    /* parent code */
#ifdef LOCK
    if(flock(fd, LOCK_EX|LOCK_NB) == -1){
      printf("error in locking by %d\n", getpid());
      exit(0);
    }
#endif
    
    sendto(fd, );
    sleep(2);
    sendto(fd, );
      
#ifdef LOCK
    if(flock(fd, LOCK_UN) == -1)
      printf("error in unlocking");
#endif
  }
}
